<template>
  <div class="bargainListDetail">
    <div class="bargainListDetail-main" v-if="powers.some((i) => i == '007')">
      <el-tabs v-model="projectTabs" v-loading="loading">
        <el-tab-pane label="付款申请管理" name="1">
          <el-collapse v-model="activeNames" style="margin: -18px 0 0 0">
            <el-collapse-item :title="'付款申请信息展示'" name="1">
              <show-data-table
                v-if="newTime !== ''"
                style="padding: -5px 0 10px 0"
                :newTime="newTime"
                :sitem="{}"
                :columns="editColumns"
              />
            </el-collapse-item>

            <el-collapse-item title="待客户上传付款凭证" name="2">
              <credentials-node :is-amount="true" />
            </el-collapse-item>

            <el-collapse-item title="待供应商确认付款" name="3">
              <div style="width:100%;display:flex;justify-content:flex-end;margin:10px 0px">
                <el-button size="mini" type="primary">确认已付款</el-button>
              </div>
            </el-collapse-item>
          </el-collapse>
        </el-tab-pane>
      </el-tabs>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import asyncRequest from "@/apis/service/customerService/paymentApply";
import privateField from '@/mixins/privateField';
import resToken from "@/mixins/resToken";
import { editColumns } from "./columns";
import { mapGetters } from "vuex";

export default {
  name: "bargainListDetail",
  mixins: [resToken,privateField],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size", "private_field", "isSupertube"]),
    powers() {
      const { btnList } = this.$store.getters;
      const tran = btnList.find((item) => item.menu_route == "paymentApplyDetail") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },

  data() {
    return {
      size: "small",
      eaxmList: [],
      editColumns,
      projectTabs: "1",
      activeNames: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "20"],
      newTime: "",
      loading: false,
      queryType: "",
      queryId: "",
      status: "",
      sitem: null,

      orderItem: {},
      moneyDirItem: {},
      moneyItem: {},
      BossItem: {},
    };
  },
  mounted() {
    this.initForm();
  },
  methods: {
    async initForm() {
      const { id, type } = this.$route.query;
      this.queryId = id;
      this.queryType = type;
      this.projectTabs = "1";
      this.loading = true;
      await this.initData();
      this.loading = false;
    },

    handleClick(row) {
      console.log(row);
    },
    async refresh() {
      this.routeReGoto("bargainList", {});
    },
    async initData() {
      this.loading = true;
      const { code, message, data } = await asyncRequest.detail({
        bargainNo: this.queryId,
      });

      this.eaxmList = [];
      this.loading = false;
      if (code === 0) {
        this.sitem = JSON.parse(JSON.stringify(data));

        const { status, exam_info } = this.sitem;
        this.orderItem = {};
        this.moneyDirItem = {};
        this.moneyItem = {};
        this.BossItem = {};
        if (exam_info && exam_info.length > 0) {
          exam_info.forEach((e) => {
            console.log(e.status);
            switch (e.info_status + "") {
              case "0":
                this.orderItem = JSON.parse(JSON.stringify(e));
                break;
              case "2":
                this.moneyDirItem = JSON.parse(JSON.stringify(e));
                break;
              case "4":
                this.moneyItem = JSON.parse(JSON.stringify(e));
                break;
              case "7":
                this.BossItem = JSON.parse(JSON.stringify(e));
                break;
              default:
                this.orderItem = JSON.parse(JSON.stringify(e));
            }
          });
          this.eaxmList = JSON.parse(JSON.stringify(exam_info));
        }

        this.status = status;

        this.getNewTime();
      } else if (code >= 100 && code <= 104) {
        await this.logout();
      } else {
        this.$message.warning(message);
      }
    },
    getNewTime() {
      this.newTime = new Date().valueOf();
    },

    // 点击业务审核的保存按钮
    async examFormSubmit(e, title) {
      if (!this.loading) {
        const { state, remark, adjunct, adjunct_name } = e;
        let model = {
          bargainNo: this.queryId,
          status: state,
          adjunct: adjunct,
          adjunct_name: adjunct_name,
          remark: remark,
        };
        await this.$confirm(`确定要提交${title}审批结果？`, {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(async () => {
            const { after_price, lower_price } = this.sitem;
            if (after_price * 1 < lower_price * 1 && state + "" + "" === "1") {
              this.loading = false;
              await this.$confirm(
                `当前商品同意议价后，售价已低于系统最低售价${this.sitem.lower_price}元！`,
                `最终售价已低于系统最低售价！是否继续？`,

                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "error",
                }
              )
                .then(async () => {
                  if (adjunct === "") {
                    this.$message.warning("越线通过，附件为必填项！");
                    return;
                  }
                  this.loading = true;
                  await this.statusSubmit(model, title);
                })
                .catch(() => {
                  this.loading = false;
                  console.log("取消1");
                });
            } else {
              await this.statusSubmit(model, title);
            }
          })
          .catch(() => {
            this.loading = false;
            console.log("取消");
          });
      }
    },
    async statusSubmit(model, title) {
      if (model.status === "0") model.status = "2";
      const { code, data, message } = await asyncRequest.status(model);
      this.loading = false;
      // console.log("res", data);
      if (code === 0) {
        this.$notify.success({
          title: title + "成功！",
          message: "",
        });
        await this.initForm();
      } else if (code >= 100 && code <= 104) {
        await this.logout();
      } else {
        this.$message.warning(message);
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.bargainListDetail {
  position: relative;
  height: 100%;
  width: 100%;
  box-sizing: border-box;
  .bargainListDetail-main {
    position: relative;
    padding: 10px;
    height: 100%;
    width: 100%;
  }
  .bargainListDetail-title {
    border-top: 1px solid #ebeef5;
    span {
      height: 50px;
      line-height: 50px;
      font-family: "微软雅黑", sans-serif;
      font-weight: 400;
      font-style: normal;
      font-size: 16fpx;
      text-align: left;
    }
  }
  /deep/ .ddiv {
    border-top: 1px solid #dcdfe6;
  }
  /deep/ .dtitle {
    width: 40px;
    text-align: center;
    height: 100%;
    min-height: 100%;
    ul {
      padding: 12px 0 0 0;
    }
  }
  /deep/ .dmain {
    padding: 20px 0 0 0;
    width: calc(100% - 40px);
    border-left: 1px solid #dcdfe6;
  }
}
</style>
